--[[
Name: AlarArtRemover.lua
Revision: $Revision: 52287 $
Author: Alar of Daggerspine
Website: http://wow.aspide.it
Documentation:
SVN:
Description:
Dependencies: Alarmod
License: GPL v2.1
--]]
--DEFAULT_CHAT_FRAME:AddMessage(GetTime().. " AlarArtRemover",1,0,0)

if not AceLibrary:HasInstance("AlarClass-2.0") then
    error("Library AlarClass-2.0 missing")
    return
end
local AlarClass = AceLibrary("AlarClass-2.0")
local AMO=AceLibrary("AlarLib-2.0")
local Id="AAR"
local Fullname="AlarArtRemover"
local Cache={}
------------------------------------------------------
AAR=AlarClass:new{
    ID="AAR",
    fullname="AlarArtRemover",
    description="Remove art from actionbars",
    debug=false, -- Testing, debug sempre attivo
}
-------------------------------------------------------------------------------
------------------------- Help definition--------------------------------------
function AAR:Initialize()
    self:RegisterDefaults("char",{
        spells={}
    })
    self:HF_Commands()
    self.HIDEGRYPHON={tipo="form",
        items={"MainMenuBarLeftEndCap","MainMenuBarRightEndCap"}
        }
    self.HIDELAGMETER={tipo="form",
                    items={"MainMenuBarPerformanceBarFrame"}
                    }
    self.HIDEMAINBAR={tipo="form",
                    items={"MainMenuBarTexture0","MainMenuBarTexture1","MainMenuBarTexture2","MainMenuBarTexture3"}
                    }
    self.HIDEPETBAR={tipo="texture",
                    items={"SlidingActionBarTexture0","SlidingActionBarTexture1"}
                    }
    self:AddToggle("HIDEGRYPHON",false,"Hide Gryphon Art")
    self:AddToggle("HIDEPETBAR",false,"Hide Pet Bar Art")
    self:AddToggle("HIDEMAINBAR",false,"Hide Main Bar Art")
    self:AddToggle("HIDELAGMETER",false,"Hide LagMeter")
end
function AAR:Enable(first)
        self:ApplyAll()
end
function AAR:Disable()

end
function AAR:ToggleTexture(forcehide,items)
    local rc
    for i,v in pairs(items) do
        self:Debug("Toggling " .. tostring(i) .. ":" .. tostring(v))
        local f=getglobal(v)
        if (f) then
            if (f:GetTexture() or forcehide) then
                rc= self:HideTexture(f,v)
            else
                rc= self:ShowTexture(f,v)
            end
        end
    end
    return rc
end
function AAR:ToggleForm(forcehide,items)
    local rc
    for i,v in pairs(items) do
        local f=getglobal(v)
        if (f) then
            if (f:IsShown() or forcehide) then
                rc=self:Hide(f,v)
            else
                rc=self:Show(f,v)
            end
        end
    end
    return rc
end
function AAR:Hide(f,v)
    f:Hide()
    return true
end
function AAR:Show(f,v)
    f:Show()
    return false
end
function AAR:HideTexture(f,v)
    Cache[v]=f:GetTexture()
    f:SetTexture(nil)
    return true
end
function AAR:ShowTexture(f,v)
    f:SetTexture(Cache[v])
    return false
end
function AAR:Apply(key,value)
    self:_Toggle(key,self:GetToggle(key))
end
function AAR:ApplyAll(event)
    for i,v in self:Vars() do
        local hide=self:GetToggle(i)
        self:_Toggle(i,hide)
    end

end
function AAR:_Toggle(button,force)
    local item=self[button]
    if (not item) then
        return
    end
    if (item.tipo == "form") then
        self:ToggleForm(force,item.items)
    elseif (item.tipo == "texture") then
        self:ToggleTexture(force,item.items)
    end
end
AAR:Register()
